var BASEURL = 'https://crm.solus.se';

var nopop = false;

$(function () {

    $('#solusclose').click(function () {
        chrome.runtime.sendMessage('hide_popup');
    });

    $('#solussearchbutton').click(function () {
        $('#solussearch').toggle();
        $('#solussearch:visible').each(function () {
            $('#solussearchfield').val("");
            $('#solussearchfield').focus();
        });
    });

    $('#nopop').click(function() {
        nopop = !nopop;
        if (nopop) {
            chrome.runtime.sendMessage('nopop');
            $('#nopop-background').addClass('text-danger');
        } else {
            chrome.runtime.sendMessage('pop');
            $('#nopop-background').removeClass('text-danger');
        }
    });

    // instantiate the bloodhound suggestion engine
    var search = new Bloodhound({
        datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name'),
        queryTokenizer: Bloodhound.tokenizers.whitespace,
        remote: {
            url: BASEURL + "/search?str=%QUERY",
            wildcard: '%QUERY'
        }
    });

    // initialize the bloodhound suggestion engine
    search.initialize();

    $('#solussearchfield').typeahead(null, {
        items: 10,
        limit: 10,
        hint: true,
        highlight: true,
        display: function (data) {
            if (data.type == 'user')
                return data.name + ' (' + data.cust + ')';
            else
                return data.name;
        },
        source: search
    });

    $('#solussearchfield').bind('typeahead:select', function (ev, obj) {
        $('#solussearch').toggle();
        if (obj) {
            if (obj.type == 'user') {
                // Användare
                $.get(BASEURL + '/user/' + obj.number, function (data) {
                    //console.log(data);
                    chrome.storage.local.set({
                        'lastmsg': data
                    }, function () {
                        $('#content').html(data);
                    });
                });
            } else if (obj.type == 'cust') {
                // Företag
                $.get(BASEURL + '/company/' + (obj.id ? obj.id : obj.domain), function (data) {
                    //console.log(data);
                    chrome.storage.local.set({
                        'lastmsg': data
                    }, function () {
                        $('#content').html(data);
                    });
                });
            }
        }
    });

    $('.tip').tip({
        position: 'left'
    });
    
    chrome.storage.local.get(['nopop'], function(items) {
        nopop = items.nopop;
        if(nopop)
            $('#nopop-background').addClass('text-danger');
    });
    
});

chrome.runtime.connect();
chrome.runtime.onMessage.addListener(
    function (request, sender) {
        if (request == 'display' || request == 'display-terminated') {
            console.log('show call');
            chrome.storage.local.get(['lastmsg'], function (items) {
                if(items.lastmsg)
                    $('#content').html(items.lastmsg);
            });
        }
    }
);
